<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Scopes/Synopsis/SymbolFactory.html -->
<!-- this view was generated by Scope -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis::SymbolFactory</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Scope">
<div class="navigation">
<span class="normal"><a href="../global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
<!-- this part was generated by Heading -->
<div class="class-module">namespace <a href="../Synopsis.html" >Synopsis</a>
</div><div class="class-name">class SymbolFactory

</div><div class="links"><div class="file">File: <a href="../../File/Synopsis/SymbolFactory.hh.html" target="detail">../Synopsis/SymbolFactory.hh</a></div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line22" ><img src="../../src-c++.png" alt="source code"/></a></div></div>   <div class="doc"><p>SymbolFactory populates a symbol table.</p>
</div>
<!-- this part was generated by Summary -->
<div class="summary">
<div class="heading">Public Enums Summary:</div>
<div class="item"><div class="synopsis"><a class="name" id="Language">Language</a> NONE, C99, CXX</div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mLanguage" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line26" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Public Member functions Summary:</div>
<div class="item"><div class="synopsis">&#160;<i>constructor</i> <span class="name"><a href="SymbolFactory.html#SymbolFactory_lLanguage_r" >SymbolFactory</a></span>(<a href="SymbolFactory.html#Language" >Language</a> = <span class="value">CXX</span>)  </div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mSymbolFactory_lLanguage_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line30" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Create a symbol lookup table for the given language.</p>
</div></div>
<div class="item"><div class="synopsis"> <a href="SymbolLookup/Scope.html" >SymbolLookup::Scope</a>* <a class="name" id="current_scope_l_r">current_scope</a>()  </div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mcurrent_scope_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line32" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="enter_scope_lconst.PTree_mNamespaceSpec_S_r">enter_scope</a>(const&#160;<a href="PTree/NamespaceSpec.html" >PTree::NamespaceSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line34" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="enter_scope_lconst.PTree_mClassSpec_S_r">enter_scope</a>(const&#160;<a href="PTree/ClassSpec.html" >PTree::ClassSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line35" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="enter_scope_lconst.PTree_mNode_S_r">enter_scope</a>(const&#160;<a href="PTree/Node.html" >PTree::Node</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line36" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="enter_scope_lconst.PTree_mFunctionDefinition_S_r">enter_scope</a>(const&#160;<a href="PTree/FunctionDefinition.html" >PTree::FunctionDefinition</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line37" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="enter_scope_lconst.PTree_mTemplateDecl_S_r">enter_scope</a>(const&#160;<a href="PTree/TemplateDecl.html" >PTree::TemplateDecl</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line38" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="enter_scope_lconst.PTree_mBlock_S_r">enter_scope</a>(const&#160;<a href="PTree/Block.html" >PTree::Block</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line39" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="leave_scope_l_r">leave_scope</a>()  </div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mleave_scope_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line40" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mDeclaration_S_r">declare</a>(const&#160;<a href="PTree/Declaration.html" >PTree::Declaration</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line42" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mTypedef_S_r">declare</a>(const&#160;<a href="PTree/Typedef.html" >PTree::Typedef</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line43" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="SymbolFactory.html#declare_lconst.PTree_mEnumSpec_S_r" >declare</a></span>(const&#160;<a href="PTree/EnumSpec.html" >PTree::EnumSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line45" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>declare the enumeration as a new TYPE as well as all the enumerators as CONST</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="SymbolFactory.html#declare_lconst.PTree_mNamespaceSpec_S_r" >declare</a></span>(const&#160;<a href="PTree/NamespaceSpec.html" >PTree::NamespaceSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line47" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>declare the namespace as a new NAMESPACE</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="SymbolFactory.html#declare_lconst.PTree_mClassSpec_S_r" >declare</a></span>(const&#160;<a href="PTree/ClassSpec.html" >PTree::ClassSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line49" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>declare the class as a new TYPE</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mTemplateDecl_S_r">declare</a>(const&#160;<a href="PTree/TemplateDecl.html" >PTree::TemplateDecl</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line50" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mTypeParameter_S_r">declare</a>(const&#160;<a href="PTree/TypeParameter.html" >PTree::TypeParameter</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line51" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mUsingDirective_S_r">declare</a>(const&#160;<a href="PTree/UsingDirective.html" >PTree::UsingDirective</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line52" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mParameterDeclaration_S_r">declare</a>(const&#160;<a href="PTree/ParameterDeclaration.html" >PTree::ParameterDeclaration</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line53" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mUsingDeclaration_S_r">declare</a>(const&#160;<a href="PTree/UsingDeclaration.html" >PTree::UsingDeclaration</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line54" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Typedefs Summary:</div>
<div class="item"><div class="synopsis">std::stack&lt;<a href="SymbolLookup/Scope.html" >SymbolLookup::Scope</a>*&gt; <a class="name" id="Scopes">Scopes</a></div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mScopes" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line57" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Member functions Summary:</div>
<div class="item"><div class="synopsis"> <a href="SymbolLookup/Scope.html" >SymbolLookup::Scope</a>* <span class="name"><a href="SymbolFactory.html#lookup_scope_of_qname_lPTree_mEncoding_A_cconst.PTree_mNode_S_r" >lookup_scope_of_qname</a></span>(<a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, const&#160;<a href="PTree/Node.html" >PTree::Node</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line62" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Lookup the scope of a qualified name.</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Data members Summary:</div>
<div class="item"><div class="synopsis"><a href="SymbolFactory.html#Language" >Language</a> <a class="name" id="my_language">my_language</a></div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mmy_language" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line64" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="SymbolFactory.html#Scopes" >Scopes</a> <a class="name" id="my_scopes">my_scopes</a></div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mmy_scopes" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line65" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="SymbolLookup/PrototypeScope.html" >SymbolLookup::PrototypeScope</a>* <span class="name"><a href="SymbolFactory.html#my_prototype" >my_prototype</a></span></div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mmy_prototype" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line70" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>When parsing a function definition the declarator is seen first,
and thus a prototype is created to hold the parameters.</p>
</div></div>
<div class="item"><div class="synopsis"><a href="SymbolLookup/TemplateParameterScope.html" >SymbolLookup::TemplateParameterScope</a>* <span class="name"><a href="SymbolFactory.html#my_template_parameters" >my_template_parameters</a></span></div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mmy_template_parameters" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line77" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>When parsing a class or function template the template-parameter-list
is seen first.</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Enumerators Summary:</div>
<div class="item"><div class="synopsis"><a class="name" id="NONE">NONE</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="C99">C99</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="CXX">CXX</a></div> <div class="doc"></div></div>
</div><!-- summary -->
<!-- this part was generated by Inheritance -->
<!-- this part was generated by Detail -->
<div class="detail">
<div class="heading">Public Member functions Details:</div>
<div class="item"><div class="synopsis">&#160;<i>constructor</i> <a class="name" id="SymbolFactory_lLanguage_r">SymbolFactory</a>(<a href="SymbolFactory.html#Language" >Language</a> = <span class="value">CXX</span>)  </div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mSymbolFactory_lLanguage_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line30" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Create a symbol lookup table for the given language.
Right now only CXX is supported.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mEnumSpec_S_r">declare</a>(const&#160;<a href="PTree/EnumSpec.html" >PTree::EnumSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line45" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>declare the enumeration as a new TYPE as well as all the enumerators as CONST</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mNamespaceSpec_S_r">declare</a>(const&#160;<a href="PTree/NamespaceSpec.html" >PTree::NamespaceSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line47" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>declare the namespace as a new NAMESPACE</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="declare_lconst.PTree_mClassSpec_S_r">declare</a>(const&#160;<a href="PTree/ClassSpec.html" >PTree::ClassSpec</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line49" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>declare the class as a new TYPE</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Private Member functions Details:</div>
<div class="item"><div class="synopsis"> <a href="SymbolLookup/Scope.html" >SymbolLookup::Scope</a>* <a class="name" id="lookup_scope_of_qname_lPTree_mEncoding_A_cconst.PTree_mNode_S_r">lookup_scope_of_qname</a>(<a href="PTree/Encoding.html" >PTree::Encoding</a>&amp;, const&#160;<a href="PTree/Node.html" >PTree::Node</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line62" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Lookup the scope of a qualified name.
The encoded name is modified in place to
refer to the unqualified name.</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Private Data members Details:</div>
<div class="item"><div class="synopsis"><a href="SymbolLookup/PrototypeScope.html" >SymbolLookup::PrototypeScope</a>* <a class="name" id="my_prototype">my_prototype</a></div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mmy_prototype" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line70" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>When parsing a function definition the declarator is seen first,
and thus a prototype is created to hold the parameters.
Later, when the function definition proper is seen, the symbols
are transfered and the prototype is deleted.</p>
</div></div>
<div class="item"><div class="synopsis"><a href="SymbolLookup/TemplateParameterScope.html" >SymbolLookup::TemplateParameterScope</a>* <a class="name" id="my_template_parameters">my_template_parameters</a></div> <div class="xref"><a href="../../XRef/xref21.html#Synopsis_mSymbolFactory_mmy_template_parameters" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/SymbolFactory.hh.html#line77" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>When parsing a class or function template the template-parameter-list
is seen first. Since ClassSpec and Declarator don't know they are part
of a template declaration, we cache it here so it gets consumed when
the Class or PrototypeScope are created.</p>
</div></div>
</div><!-- detail -->

<div class="logo">Generated on Thu Apr 16 16:27:41 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
